/*
 * Export a block device.
 *
 * Copyright (C) 2018, 2019, 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

/* Implemented interface. */

#include <fsserver/user_filesystem_resource.h>



/* Block device. */

class Block_device : public UserFilesystemResource
{
private:
  char *_block;
  size_t _size;

public:
  /* Initialise the device. */

  explicit Block_device(Paging *paging, char *block, size_t size)
  : UserFilesystemResource(paging), _block(block), _size(size)
  {
  }

  /* A mechanism for obtaining resources for filesystem objects. */

  virtual long open_object_resource(fs_object_t *fsobj, int flags,
                                    Resource **resource);
};
